/*
  pbsmooth Version 1.01
  Copyright (C) 2001-2002  hdk (Hideki EIRAKU)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA

  -- 
  E-mail: hdk@SoftHome.net
*/

#include <windows.h>

HINSTANCE hInstDLL;
struct sharedata
{
  HHOOK hhook;
  HWND hwndClient;
};
int clientflag;
HANDLE hmapfile;
char sharekey[] = "share_pbsmoothdll";
char propstr[] = "pbsmoothdll";
struct sharedata *sharemem;
struct sharedata shareclient;
struct wnddata
{
  WNDPROC oldproc;
};

BOOL WINAPI
DllMain (HINSTANCE hInstDLLIn, DWORD fdwReason, LPVOID lpvReserved)
{
  struct sharedata *p;

  hInstDLL = hInstDLLIn;
  if (fdwReason == DLL_PROCESS_ATTACH)
    {
      sharemem = 0;
      clientflag = 0;
      hmapfile = OpenFileMapping (FILE_MAP_ALL_ACCESS, TRUE, sharekey);
      if (hmapfile)
	{
	  p = MapViewOfFile (hmapfile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	  if (!p)
	    {
	      CloseHandle (hmapfile);
	      hmapfile = 0;
	      return 0;
	    }
	  sharemem = &shareclient;
	  CopyMemory (sharemem, p, sizeof (struct sharedata));
	  UnmapViewOfFile (p);
	  CloseHandle (hmapfile);
	  hmapfile = 0;
	  if (shareclient.hhook)
	    clientflag = 1;
	}
    }
  return TRUE;
}

LRESULT CALLBACK
WndProc (HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
  CREATESTRUCT *p;
  WNDPROC proc;
  HLOCAL q;
  struct wnddata *qq;

  q = (HLOCAL)GetProp (hwnd, propstr);
  if (!q)
    return DefWindowProc (hwnd, nMsg, wParam, lParam);
  qq = (struct wnddata *)q;
  proc = qq->oldproc;
  switch (nMsg)
    {
    case WM_CREATE:
      p = (CREATESTRUCT *)lParam;
      p->style |= 1;
    case WM_DESTROY:
      SetWindowLong (hwnd, GWL_WNDPROC, (LONG)proc);
      RemoveProp (hwnd, propstr);
      LocalFree (q);
    }
  return CallWindowProc (proc, hwnd, nMsg, wParam, lParam);
}

LRESULT CALLBACK
CallWndProc (int nCode, WPARAM wParam, LPARAM lParam)
{
  CWPSTRUCT *p;
  char buf[32];
  int len;
  HLOCAL q;
  struct wnddata *qq;

  if (nCode < 0)
    return CallNextHookEx (shareclient.hhook, nCode, wParam, lParam);
  if (nCode == HC_ACTION)
    {
      p = (CWPSTRUCT *)lParam;
      if (p->message == WM_CREATE)
	{
	  len = GetClassName (p->hwnd, buf, 32);
	  if (len == 17 || len == 15 || len == 12 || len == 21 || len == 19)
	    {
	      buf[len] = 0;
	      if (!lstrcmpi (buf, "msctls_progress32") ||
		  !lstrcmpi (buf, "msctls_progress") ||
		  !lstrcmpi (buf, "TProgressBar") ||
		  !lstrcmpi (buf, "ProgressBar20WndClass") ||
		  !lstrcmpi (buf, "ProgressBarWndClass"))
		{
		  q = LocalAlloc (0, sizeof (struct wnddata));
		  if (q)
		    {
		      qq = (struct wnddata *)q;
		      if (SetProp (p->hwnd, propstr, (HANDLE)q))
			qq->oldproc = (WNDPROC)
			  SetWindowLong (p->hwnd, GWL_WNDPROC, (LONG)WndProc);
		      else
			LocalFree (q);
		    }
		}
	    }
	}
    }
  return CallNextHookEx (shareclient.hhook, nCode, wParam, lParam);
}

HWND
SetHook (HWND hwnd)
{
  int f = 0;

  if (clientflag)
    return shareclient.hwndClient;
  hmapfile = CreateFileMapping ((HANDLE)0xffffffff, 0, PAGE_READWRITE, 0,
				sizeof (struct sharedata), sharekey);
  if (!hmapfile)
    return INVALID_HANDLE_VALUE;
  if (GetLastError () == ERROR_ALREADY_EXISTS)
    f = 1;
  sharemem = MapViewOfFile (hmapfile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
  if (!sharemem)
    {
      CloseHandle (hmapfile);
      hmapfile = 0;
      return INVALID_HANDLE_VALUE;
    }
  if (f)
    {
      HWND a;

      a = sharemem->hwndClient;
      if (!a && sharemem->hhook) /* hwndClient of ver.1.00 is NULL! */
	a = INVALID_HANDLE_VALUE;
      if (a)
	{
	  UnmapViewOfFile (sharemem);
	  sharemem = 0;
	  CloseHandle (hmapfile);
	  hmapfile = 0;
	  return a;
	}
    }
  sharemem->hwndClient = hwnd;
  sharemem->hhook = SetWindowsHookEx (WH_CALLWNDPROC,
				      (HOOKPROC)CallWndProc, hInstDLL, 0);
  shareclient = *sharemem;
  UnmapViewOfFile (sharemem);
  sharemem = 0;
  return 0;
}

void
ReleaseHook (void)
{
  if (hmapfile)
    {
      if (shareclient.hhook)
	{
	  UnhookWindowsHookEx (shareclient.hhook);
	  shareclient.hhook = 0;
	  sharemem = MapViewOfFile (hmapfile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	  if (sharemem)
	    sharemem->hhook = 0, sharemem->hwndClient = 0,
	      UnmapViewOfFile (sharemem);
	  sharemem = 0;
	  CloseHandle (hmapfile);
	  hmapfile = 0;
	}
    }
}
